var _templateObject;

function _taggedTemplateLiteralLoose(strings, raw) { if (!raw) { raw = strings.slice(0); } strings.raw = raw; return strings; }

/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
import React from 'react';
import { styled } from '@superset-ui/core';
import Echart from './Echart'; // The following Styles component is a <div> element, which has been styled using Emotion
// For docs, visit https://emotion.sh/docs/styled
// Theming variables are provided for your use via a ThemeProvider
// imported from @superset-ui/core. For variables available, please visit
// https://github.com/apache-superset/superset-ui/blob/master/packages/superset-ui-core/src/style/index.ts

var Styles = styled.div(_templateObject || (_templateObject = _taggedTemplateLiteralLoose(["\n  background-color: ", ";\n  padding: ", "px;\n  border-radius: ", "px;\n  height: ", "px;\n  width: ", "px;\n\n  h3 {\n    /* You can use your props to control CSS! */\n    margin-top: 0;\n    margin-bottom: ", "px;\n    font-size: ", "px;\n    font-weight: ", ";\n  }\n\n  pre {\n    height: ", "px;\n  }\n"])), _ref => {
  var {
    theme
  } = _ref;
  return theme.colors.secondary.light2;
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.gridUnit * 4;
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.gridUnit * 2;
}, _ref4 => {
  var {
    height
  } = _ref4;
  return height;
}, _ref5 => {
  var {
    width
  } = _ref5;
  return width;
}, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.gridUnit * 3;
}, _ref7 => {
  var {
    theme,
    headerFontSize
  } = _ref7;
  return theme.typography.sizes[headerFontSize];
}, _ref8 => {
  var {
    theme,
    boldText
  } = _ref8;
  return theme.typography.weights[boldText ? 'bold' : 'normal'];
}, _ref9 => {
  var {
    theme,
    headerFontSize,
    height
  } = _ref9;
  return height - theme.gridUnit * 12 - theme.typography.sizes[headerFontSize];
});
export default function SupersetPluginEchartHeatmap(props) {
  // height and width are the height and width of the DOM element as it exists in the dashboard.
  // There is also a `data` prop, which is, of course, your DATA 🎉
  var {
    data,
    height,
    width,
    colsArray,
    metrics
  } = props;
  var dic = {};
  var xArray = [];
  var yArray = [];
  var max = 0;
  var min = 0;

  for (var i in data) {
    for (var co in colsArray) {
      if (co == 0) {
        if (dic[data[i][colsArray[co]]] == undefined) {
          dic[data[i][colsArray[co]]] = {};
          xArray.push(data[i][colsArray[co]]);
        }
      } else if (co == 1) {
        dic[data[i][colsArray[0]]][data[i][colsArray[co]]] = data[i][metrics];
        var yval = data[i][colsArray[co]];

        if (yArray.indexOf(yval) == -1) {
          yArray.push(yval);
        }

        if (data[i][metrics] > max) {
          max = data[i][metrics];
        }

        if (data[i][metrics] < min) {
          min = data[i][metrics];
        }
      }
    }
  }

  var data33 = [];

  for (var _i in xArray) {
    for (var j in dic[xArray[_i]]) {
      data33.push([parseInt(_i), yArray.indexOf(j), dic[xArray[_i]][j]]);
    }
  }

  var data32 = data33.map(function (item) {
    return [item[1], item[0], item[2] || '-'];
  });
  var option = {
    tooltip: {
      position: 'top'
    },
    grid: {
      height: '85%',
      width: '90%',
      top: '5%'
    },
    xAxis: {
      type: 'category',
      data: yArray,
      splitArea: {
        show: true
      }
    },
    yAxis: {
      type: 'category',
      data: xArray,
      splitArea: {
        show: true
      }
    },
    visualMap: {
      min: min,
      max: max,
      calculable: true,
      orient: 'horizontal',
      left: 'center',
      bottom: '1%'
    },
    series: [{
      name: 'Punch Card',
      type: 'heatmap',
      data: data32,
      label: {
        show: true
      },
      emphasis: {
        itemStyle: {
          shadowBlur: 10,
          shadowColor: 'rgba(0, 0, 0, 0.5)'
        }
      }
    }]
  };
  return /*#__PURE__*/React.createElement(Echart, {
    height: height,
    width: width,
    echartOptions: option
  });
}